_Display_Init:
;LED_Driver.c,23 :: 		void Display_Init(void) {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;LED_Driver.c,26 :: 		GPIO_Config(&GPIOD_BASE, _GPIO_PINMASK_2, _GPIO_CFG_DIGITAL_OUTPUT);
MOVW	R2, #20
MOVT	R2, #8
MOVW	R1, #4
MOVW	R0, #lo_addr(GPIOD_BASE+0)
MOVT	R0, #hi_addr(GPIOD_BASE+0)
BL	_GPIO_Config+0
;LED_Driver.c,27 :: 		CS_LED = 1;
MOVS	R1, #1
SXTB	R1, R1
MOVW	R0, #lo_addr(GPIOD_ODR+0)
MOVT	R0, #hi_addr(GPIOD_ODR+0)
STR	R1, [R0, #0]
;LED_Driver.c,31 :: 		_SPI_SSM_ENABLE | _SPI_SSI_1, &_GPIO_MODULE_SPI3_PC10_11_12);
MOVW	R2, #lo_addr(__GPIO_MODULE_SPI3_PC10_11_12+0)
MOVT	R2, #hi_addr(__GPIO_MODULE_SPI3_PC10_11_12+0)
MOVW	R1, #2820
;LED_Driver.c,29 :: 		SPI3_Init_Advanced(_SPI_FPCLK_DIV64, _SPI_MASTER  | _SPI_16_BIT | _SPI_CLK_IDLE_LOW |
MOVS	R0, #5
;LED_Driver.c,31 :: 		_SPI_SSM_ENABLE | _SPI_SSI_1, &_GPIO_MODULE_SPI3_PC10_11_12);
BL	_SPI3_Init_Advanced+0
;LED_Driver.c,33 :: 		Display_Setup();
BL	_Display_Setup+0
;LED_Driver.c,34 :: 		}
L_end_Display_Init:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _Display_Init
_Display_Write:
;LED_Driver.c,41 :: 		void Display_Write(unsigned _data) {
; _data start address is: 0 (R0)
SUB	SP, SP, #4
STR	LR, [SP, #0]
; _data end address is: 0 (R0)
; _data start address is: 0 (R0)
;LED_Driver.c,43 :: 		CS_LED = 0;
MOVS	R2, #0
SXTB	R2, R2
MOVW	R1, #lo_addr(GPIOD_ODR+0)
MOVT	R1, #hi_addr(GPIOD_ODR+0)
STR	R2, [R1, #0]
;LED_Driver.c,44 :: 		SPI3_Write(_data);
; _data end address is: 0 (R0)
BL	_SPI3_Write+0
;LED_Driver.c,45 :: 		CS_LED = 1;
MOVS	R2, #1
SXTB	R2, R2
MOVW	R1, #lo_addr(GPIOD_ODR+0)
MOVT	R1, #hi_addr(GPIOD_ODR+0)
STR	R2, [R1, #0]
;LED_Driver.c,46 :: 		}
L_end_Display_Write:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _Display_Write
_Display_Setup:
;LED_Driver.c,52 :: 		void Display_Setup(void) {
SUB	SP, SP, #12
STR	LR, [SP, #0]
;LED_Driver.c,55 :: 		Hi(CmdDat) = CONFIGURATION;
ADD	R2, SP, #4
STR	R2, [SP, #8]
ADDS	R1, R2, #1
MOVS	R0, #4
STRB	R0, [R1, #0]
;LED_Driver.c,56 :: 		Lo(CmdDat) = Configuration;       // Configuration to normal
MOVW	R0, #lo_addr(_Configuration+0)
MOVT	R0, #hi_addr(_Configuration+0)
LDRB	R0, [R0, #0]
STRB	R0, [R2, #0]
;LED_Driver.c,57 :: 		Display_Write(CmdDat);
LDRH	R0, [SP, #4]
BL	_Display_Write+0
;LED_Driver.c,59 :: 		Hi(CmdDat) = SCAN_LIMIT;
ADD	R0, SP, #4
ADDS	R1, R0, #1
MOVS	R0, #3
STRB	R0, [R1, #0]
;LED_Driver.c,60 :: 		Lo(CmdDat) = 0x07;                // Scan limit to 8 digits
MOVS	R1, #7
LDR	R0, [SP, #8]
STRB	R1, [R0, #0]
;LED_Driver.c,61 :: 		Display_Write(CmdDat);
LDRH	R0, [SP, #4]
BL	_Display_Write+0
;LED_Driver.c,63 :: 		Hi(CmdDat) = DECODE_MODE;
ADD	R0, SP, #4
ADDS	R1, R0, #1
MOVS	R0, #1
STRB	R0, [R1, #0]
;LED_Driver.c,64 :: 		Lo(CmdDat) = 0xFF;                // Decode mode to 8-digit HEX
MOVS	R1, #255
LDR	R0, [SP, #8]
STRB	R1, [R0, #0]
;LED_Driver.c,65 :: 		Display_Write(CmdDat);
LDRH	R0, [SP, #4]
BL	_Display_Write+0
;LED_Driver.c,67 :: 		Hi(CmdDat) = INTENSITY;
ADD	R0, SP, #4
ADDS	R1, R0, #1
MOVS	R0, #2
STRB	R0, [R1, #0]
;LED_Driver.c,68 :: 		Lo(CmdDat) = Intensity;           // Initial intensity is 1/2 brightness
MOVW	R0, #lo_addr(_Intensity+0)
MOVT	R0, #hi_addr(_Intensity+0)
LDRB	R1, [R0, #0]
LDR	R0, [SP, #8]
STRB	R1, [R0, #0]
;LED_Driver.c,69 :: 		Display_Write(CmdDat);
LDRH	R0, [SP, #4]
BL	_Display_Write+0
;LED_Driver.c,70 :: 		}
L_end_Display_Setup:
LDR	LR, [SP, #0]
ADD	SP, SP, #12
BX	LR
; end of _Display_Setup
_DisplayAll:
;LED_Driver.c,76 :: 		char DisplayAll(char *Msg) {
SUB	SP, SP, #16
STR	LR, [SP, #0]
STR	R0, [SP, #12]
;LED_Driver.c,81 :: 		if ((strlen(Msg) > 0) && (strlen(Msg) < 9)) {
LDR	R0, [SP, #12]
BL	_strlen+0
CMP	R0, #0
IT	LE
BLE	L__DisplayAll33
LDR	R0, [SP, #12]
BL	_strlen+0
CMP	R0, #9
IT	GE
BGE	L__DisplayAll32
L__DisplayAll31:
;LED_Driver.c,82 :: 		for (i=0;i<strlen(Msg);i++) {
MOVS	R1, #0
STRB	R1, [SP, #4]
L_DisplayAll3:
LDR	R0, [SP, #12]
BL	_strlen+0
LDRB	R1, [SP, #4]
CMP	R1, R0
IT	GE
BGE	L_DisplayAll4
;LED_Driver.c,83 :: 		Hi(CmdDat) = DIG0P0P1 + i;
ADD	R3, SP, #6
ADDS	R2, R3, #1
LDRB	R1, [SP, #4]
ADDS	R1, #96
STRB	R1, [R2, #0]
;LED_Driver.c,84 :: 		Lo(CmdDat) = Msg[i];
LDRB	R2, [SP, #4]
LDR	R1, [SP, #12]
ADDS	R1, R1, R2
LDRB	R1, [R1, #0]
STRB	R1, [R3, #0]
;LED_Driver.c,85 :: 		Display_Write(CmdDat);
LDRH	R0, [SP, #6]
BL	_Display_Write+0
;LED_Driver.c,88 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
STR	R0, [SP, #8]
;LED_Driver.c,89 :: 		sprintf(BufNum,"0x%04X",CmdDat);
LDRH	R3, [SP, #6]
MOVW	R2, #lo_addr(?lstr_1_LED_Driver+0)
MOVT	R2, #hi_addr(?lstr_1_LED_Driver+0)
MOV	R1, R0
PUSH	(R3)
PUSH	(R2)
PUSH	(R1)
BL	_sprintf+0
ADD	SP, SP, #12
;LED_Driver.c,90 :: 		USB_PutQueue(BufNum);
LDR	R0, [SP, #8]
BL	_USB_PutQueue+0
;LED_Driver.c,82 :: 		for (i=0;i<strlen(Msg);i++) {
LDRB	R1, [SP, #4]
ADDS	R1, R1, #1
STRB	R1, [SP, #4]
;LED_Driver.c,91 :: 		}
IT	AL
BAL	L_DisplayAll3
L_DisplayAll4:
;LED_Driver.c,92 :: 		return 0;
MOVS	R0, #0
IT	AL
BAL	L_end_DisplayAll
;LED_Driver.c,81 :: 		if ((strlen(Msg) > 0) && (strlen(Msg) < 9)) {
L__DisplayAll33:
L__DisplayAll32:
;LED_Driver.c,95 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
STR	R0, [SP, #8]
;LED_Driver.c,96 :: 		sprintf(BufNum,"Length: %d",strlen(Msg));
LDR	R0, [SP, #12]
BL	_strlen+0
MOVW	R2, #lo_addr(?lstr_2_LED_Driver+0)
MOVT	R2, #hi_addr(?lstr_2_LED_Driver+0)
LDR	R1, [SP, #8]
PUSH	(R0)
PUSH	(R2)
PUSH	(R1)
BL	_sprintf+0
ADD	SP, SP, #12
;LED_Driver.c,97 :: 		USB_PutQueue(BufNum);
LDR	R0, [SP, #8]
BL	_USB_PutQueue+0
;LED_Driver.c,99 :: 		return 1;
MOVS	R0, #1
;LED_Driver.c,101 :: 		}
L_end_DisplayAll:
LDR	LR, [SP, #0]
ADD	SP, SP, #16
BX	LR
; end of _DisplayAll
_SetDigit:
;LED_Driver.c,108 :: 		void SetDigit(char Digit, char _data, char DecPt) {
; DecPt start address is: 8 (R2)
; _data start address is: 4 (R1)
; Digit start address is: 0 (R0)
SUB	SP, SP, #12
STR	LR, [SP, #0]
STRB	R1, [SP, #4]
UXTB	R1, R0
LDRB	R0, [SP, #4]
; DecPt end address is: 8 (R2)
; _data end address is: 4 (R1)
; Digit end address is: 0 (R0)
; Digit start address is: 4 (R1)
; _data start address is: 0 (R0)
; DecPt start address is: 8 (R2)
;LED_Driver.c,112 :: 		if ((Digit >= 0) && (Digit <=8)) {
CMP	R1, #0
IT	CC
BCC	L__SetDigit36
CMP	R1, #8
IT	HI
BHI	L__SetDigit35
L__SetDigit34:
;LED_Driver.c,113 :: 		switch (Digit) {
IT	AL
BAL	L_SetDigit10
; Digit end address is: 4 (R1)
;LED_Driver.c,114 :: 		case 0:
L_SetDigit12:
;LED_Driver.c,115 :: 		Hi(CmdDat) = DIG0P0P1 + 0;
ADD	R5, SP, #8
ADDS	R4, R5, #1
MOVS	R3, #96
STRB	R3, [R4, #0]
;LED_Driver.c,116 :: 		Lo(CmdDat) = _data;
STRB	R0, [R5, #0]
; _data end address is: 0 (R0)
;LED_Driver.c,117 :: 		if (DecPt) Lo(CmdDat) |= 0x80;
CMP	R2, #0
IT	EQ
BEQ	L_SetDigit13
; DecPt end address is: 8 (R2)
ADD	R4, SP, #8
LDRB	R3, [R4, #0]
ORR	R3, R3, #128
STRB	R3, [R4, #0]
L_SetDigit13:
;LED_Driver.c,118 :: 		break;
IT	AL
BAL	L_SetDigit11
;LED_Driver.c,119 :: 		case 1:
L_SetDigit14:
;LED_Driver.c,120 :: 		Hi(CmdDat) = DIG0P0P1 + 1;
; DecPt start address is: 8 (R2)
; _data start address is: 0 (R0)
ADD	R5, SP, #8
ADDS	R4, R5, #1
MOVS	R3, #97
STRB	R3, [R4, #0]
;LED_Driver.c,121 :: 		Lo(CmdDat) = _data;
STRB	R0, [R5, #0]
; _data end address is: 0 (R0)
;LED_Driver.c,122 :: 		if (DecPt) Lo(CmdDat) |= 0x80;
CMP	R2, #0
IT	EQ
BEQ	L_SetDigit15
; DecPt end address is: 8 (R2)
ADD	R4, SP, #8
LDRB	R3, [R4, #0]
ORR	R3, R3, #128
STRB	R3, [R4, #0]
L_SetDigit15:
;LED_Driver.c,123 :: 		break;
IT	AL
BAL	L_SetDigit11
;LED_Driver.c,124 :: 		case 2:
L_SetDigit16:
;LED_Driver.c,125 :: 		Hi(CmdDat) = DIG0P0P1 + 2;
; DecPt start address is: 8 (R2)
; _data start address is: 0 (R0)
ADD	R5, SP, #8
ADDS	R4, R5, #1
MOVS	R3, #98
STRB	R3, [R4, #0]
;LED_Driver.c,126 :: 		Lo(CmdDat) = _data;
STRB	R0, [R5, #0]
; _data end address is: 0 (R0)
;LED_Driver.c,127 :: 		if (DecPt) Lo(CmdDat) |= 0x80;
CMP	R2, #0
IT	EQ
BEQ	L_SetDigit17
; DecPt end address is: 8 (R2)
ADD	R4, SP, #8
LDRB	R3, [R4, #0]
ORR	R3, R3, #128
STRB	R3, [R4, #0]
L_SetDigit17:
;LED_Driver.c,128 :: 		break;
IT	AL
BAL	L_SetDigit11
;LED_Driver.c,129 :: 		case 3:
L_SetDigit18:
;LED_Driver.c,130 :: 		Hi(CmdDat) = DIG0P0P1 + 3;
; DecPt start address is: 8 (R2)
; _data start address is: 0 (R0)
ADD	R5, SP, #8
ADDS	R4, R5, #1
MOVS	R3, #99
STRB	R3, [R4, #0]
;LED_Driver.c,131 :: 		Lo(CmdDat) = _data;
STRB	R0, [R5, #0]
; _data end address is: 0 (R0)
;LED_Driver.c,132 :: 		if (DecPt) Lo(CmdDat) |= 0x80;
CMP	R2, #0
IT	EQ
BEQ	L_SetDigit19
; DecPt end address is: 8 (R2)
ADD	R4, SP, #8
LDRB	R3, [R4, #0]
ORR	R3, R3, #128
STRB	R3, [R4, #0]
L_SetDigit19:
;LED_Driver.c,133 :: 		break;
IT	AL
BAL	L_SetDigit11
;LED_Driver.c,134 :: 		case 4:
L_SetDigit20:
;LED_Driver.c,135 :: 		Hi(CmdDat) = DIG0P0P1 + 4;
; DecPt start address is: 8 (R2)
; _data start address is: 0 (R0)
ADD	R5, SP, #8
ADDS	R4, R5, #1
MOVS	R3, #100
STRB	R3, [R4, #0]
;LED_Driver.c,136 :: 		Lo(CmdDat) = _data;
STRB	R0, [R5, #0]
; _data end address is: 0 (R0)
;LED_Driver.c,137 :: 		if (DecPt) Lo(CmdDat) |= 0x80;
CMP	R2, #0
IT	EQ
BEQ	L_SetDigit21
; DecPt end address is: 8 (R2)
ADD	R4, SP, #8
LDRB	R3, [R4, #0]
ORR	R3, R3, #128
STRB	R3, [R4, #0]
L_SetDigit21:
;LED_Driver.c,138 :: 		break;
IT	AL
BAL	L_SetDigit11
;LED_Driver.c,139 :: 		case 5:
L_SetDigit22:
;LED_Driver.c,140 :: 		Hi(CmdDat) = DIG0P0P1 + 5;
; DecPt start address is: 8 (R2)
; _data start address is: 0 (R0)
ADD	R5, SP, #8
ADDS	R4, R5, #1
MOVS	R3, #101
STRB	R3, [R4, #0]
;LED_Driver.c,141 :: 		Lo(CmdDat) = _data;
STRB	R0, [R5, #0]
; _data end address is: 0 (R0)
;LED_Driver.c,142 :: 		if (DecPt) Lo(CmdDat) |= 0x80;
CMP	R2, #0
IT	EQ
BEQ	L_SetDigit23
; DecPt end address is: 8 (R2)
ADD	R4, SP, #8
LDRB	R3, [R4, #0]
ORR	R3, R3, #128
STRB	R3, [R4, #0]
L_SetDigit23:
;LED_Driver.c,143 :: 		break;
IT	AL
BAL	L_SetDigit11
;LED_Driver.c,144 :: 		case 6:
L_SetDigit24:
;LED_Driver.c,145 :: 		Hi(CmdDat) = DIG0P0P1 + 6;
; DecPt start address is: 8 (R2)
; _data start address is: 0 (R0)
ADD	R5, SP, #8
ADDS	R4, R5, #1
MOVS	R3, #102
STRB	R3, [R4, #0]
;LED_Driver.c,146 :: 		Lo(CmdDat) = _data;
STRB	R0, [R5, #0]
; _data end address is: 0 (R0)
;LED_Driver.c,147 :: 		if (DecPt) Lo(CmdDat) |= 0x80;
CMP	R2, #0
IT	EQ
BEQ	L_SetDigit25
; DecPt end address is: 8 (R2)
ADD	R4, SP, #8
LDRB	R3, [R4, #0]
ORR	R3, R3, #128
STRB	R3, [R4, #0]
L_SetDigit25:
;LED_Driver.c,148 :: 		break;
IT	AL
BAL	L_SetDigit11
;LED_Driver.c,149 :: 		case 7:
L_SetDigit26:
;LED_Driver.c,150 :: 		Hi(CmdDat) = DIG0P0P1 + 7;
; DecPt start address is: 8 (R2)
; _data start address is: 0 (R0)
ADD	R5, SP, #8
ADDS	R4, R5, #1
MOVS	R3, #103
STRB	R3, [R4, #0]
;LED_Driver.c,151 :: 		Lo(CmdDat) = _data;
STRB	R0, [R5, #0]
; _data end address is: 0 (R0)
;LED_Driver.c,152 :: 		if (DecPt) Lo(CmdDat) |= 0x80;
CMP	R2, #0
IT	EQ
BEQ	L_SetDigit27
; DecPt end address is: 8 (R2)
ADD	R4, SP, #8
LDRB	R3, [R4, #0]
ORR	R3, R3, #128
STRB	R3, [R4, #0]
L_SetDigit27:
;LED_Driver.c,153 :: 		break;
IT	AL
BAL	L_SetDigit11
;LED_Driver.c,154 :: 		}
L_SetDigit10:
; DecPt start address is: 8 (R2)
; _data start address is: 0 (R0)
; Digit start address is: 4 (R1)
CMP	R1, #0
IT	EQ
BEQ	L_SetDigit12
CMP	R1, #1
IT	EQ
BEQ	L_SetDigit14
CMP	R1, #2
IT	EQ
BEQ	L_SetDigit16
CMP	R1, #3
IT	EQ
BEQ	L_SetDigit18
CMP	R1, #4
IT	EQ
BEQ	L_SetDigit20
CMP	R1, #5
IT	EQ
BEQ	L_SetDigit22
CMP	R1, #6
IT	EQ
BEQ	L_SetDigit24
CMP	R1, #7
IT	EQ
BEQ	L_SetDigit26
; Digit end address is: 4 (R1)
; _data end address is: 0 (R0)
; DecPt end address is: 8 (R2)
L_SetDigit11:
;LED_Driver.c,155 :: 		Display_Write(CmdDat);
LDRH	R0, [SP, #8]
BL	_Display_Write+0
;LED_Driver.c,156 :: 		} else {
IT	AL
BAL	L_SetDigit28
;LED_Driver.c,112 :: 		if ((Digit >= 0) && (Digit <=8)) {
L__SetDigit36:
; Digit start address is: 4 (R1)
L__SetDigit35:
;LED_Driver.c,158 :: 		BufNum = GetBuffer();
STRB	R1, [SP, #4]
BL	_GetBuffer+0
LDRB	R1, [SP, #4]
; BufNum start address is: 8 (R2)
MOV	R2, R0
;LED_Driver.c,159 :: 		sprintf(BufNum,"Digit error: %d",Digit);
MOVW	R4, #lo_addr(?lstr_3_LED_Driver+0)
MOVT	R4, #hi_addr(?lstr_3_LED_Driver+0)
MOV	R3, R0
STR	R2, [SP, #4]
; Digit end address is: 4 (R1)
PUSH	(R1)
PUSH	(R4)
PUSH	(R3)
BL	_sprintf+0
ADD	SP, SP, #12
LDR	R2, [SP, #4]
;LED_Driver.c,160 :: 		USB_PutQueue(BufNum);
MOV	R0, R2
; BufNum end address is: 8 (R2)
BL	_USB_PutQueue+0
;LED_Driver.c,161 :: 		}
L_SetDigit28:
;LED_Driver.c,162 :: 		}
L_end_SetDigit:
LDR	LR, [SP, #0]
ADD	SP, SP, #12
BX	LR
; end of _SetDigit
_SetDecodeReg:
;LED_Driver.c,171 :: 		void SetDecodeReg(char Mask) {
; Mask start address is: 0 (R0)
SUB	SP, SP, #8
STR	LR, [SP, #0]
; Mask end address is: 0 (R0)
; Mask start address is: 0 (R0)
;LED_Driver.c,174 :: 		Hi(CmdDat) = DECODE_MODE;
ADD	R3, SP, #4
ADDS	R2, R3, #1
MOVS	R1, #1
STRB	R1, [R2, #0]
;LED_Driver.c,175 :: 		Lo(CmdDat) = Mask;
STRB	R0, [R3, #0]
; Mask end address is: 0 (R0)
;LED_Driver.c,176 :: 		Display_Write(CmdDat);
LDRH	R0, [SP, #4]
BL	_Display_Write+0
;LED_Driver.c,177 :: 		}
L_end_SetDecodeReg:
LDR	LR, [SP, #0]
ADD	SP, SP, #8
BX	LR
; end of _SetDecodeReg
_LowerIntensity:
;LED_Driver.c,182 :: 		void LowerIntensity(void) {
SUB	SP, SP, #12
STR	LR, [SP, #0]
;LED_Driver.c,186 :: 		if (Intensity > 0) {
MOVW	R0, #lo_addr(_Intensity+0)
MOVT	R0, #hi_addr(_Intensity+0)
LDRB	R0, [R0, #0]
CMP	R0, #0
IT	LS
BLS	L_LowerIntensity29
;LED_Driver.c,187 :: 		Intensity -= 1;
MOVW	R3, #lo_addr(_Intensity+0)
MOVT	R3, #hi_addr(_Intensity+0)
LDRB	R0, [R3, #0]
SUBS	R0, R0, #1
STRB	R0, [R3, #0]
;LED_Driver.c,188 :: 		Hi(CmdDat) = INTENSITY;
ADD	R2, SP, #8
ADDS	R1, R2, #1
MOVS	R0, #2
STRB	R0, [R1, #0]
;LED_Driver.c,189 :: 		Lo(CmdDat) = Intensity;
MOV	R0, R3
LDRB	R0, [R0, #0]
STRB	R0, [R2, #0]
;LED_Driver.c,190 :: 		Display_Write(CmdDat);
LDRH	R0, [SP, #8]
BL	_Display_Write+0
;LED_Driver.c,191 :: 		}
L_LowerIntensity29:
;LED_Driver.c,193 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
; BufNum start address is: 12 (R3)
MOV	R3, R0
;LED_Driver.c,194 :: 		sprintf(BufNum,"Intensity: %d",Intensity);
MOVW	R1, #lo_addr(_Intensity+0)
MOVT	R1, #hi_addr(_Intensity+0)
LDRB	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_4_LED_Driver+0)
MOVT	R1, #hi_addr(?lstr_4_LED_Driver+0)
STR	R3, [SP, #4]
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #12
LDR	R3, [SP, #4]
;LED_Driver.c,195 :: 		USB_PutQueue(BufNum);
MOV	R0, R3
; BufNum end address is: 12 (R3)
BL	_USB_PutQueue+0
;LED_Driver.c,196 :: 		}
L_end_LowerIntensity:
LDR	LR, [SP, #0]
ADD	SP, SP, #12
BX	LR
; end of _LowerIntensity
_RaiseIntensity:
;LED_Driver.c,201 :: 		void RaiseIntensity(void) {
SUB	SP, SP, #12
STR	LR, [SP, #0]
;LED_Driver.c,205 :: 		if (Intensity < 0x0F) {
MOVW	R0, #lo_addr(_Intensity+0)
MOVT	R0, #hi_addr(_Intensity+0)
LDRB	R0, [R0, #0]
CMP	R0, #15
IT	CS
BCS	L_RaiseIntensity30
;LED_Driver.c,206 :: 		Intensity += 1;
MOVW	R3, #lo_addr(_Intensity+0)
MOVT	R3, #hi_addr(_Intensity+0)
LDRB	R0, [R3, #0]
ADDS	R0, R0, #1
STRB	R0, [R3, #0]
;LED_Driver.c,207 :: 		Hi(CmdDat) = INTENSITY;
ADD	R2, SP, #8
ADDS	R1, R2, #1
MOVS	R0, #2
STRB	R0, [R1, #0]
;LED_Driver.c,208 :: 		Lo(CmdDat) = Intensity;
MOV	R0, R3
LDRB	R0, [R0, #0]
STRB	R0, [R2, #0]
;LED_Driver.c,209 :: 		Display_Write(CmdDat);
LDRH	R0, [SP, #8]
BL	_Display_Write+0
;LED_Driver.c,210 :: 		}
L_RaiseIntensity30:
;LED_Driver.c,212 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
; BufNum start address is: 12 (R3)
MOV	R3, R0
;LED_Driver.c,213 :: 		sprintf(BufNum,"Intensity: %d",Intensity);
MOVW	R1, #lo_addr(_Intensity+0)
MOVT	R1, #hi_addr(_Intensity+0)
LDRB	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_5_LED_Driver+0)
MOVT	R1, #hi_addr(?lstr_5_LED_Driver+0)
STR	R3, [SP, #4]
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #12
LDR	R3, [SP, #4]
;LED_Driver.c,214 :: 		USB_PutQueue(BufNum);
MOV	R0, R3
; BufNum end address is: 12 (R3)
BL	_USB_PutQueue+0
;LED_Driver.c,215 :: 		}
L_end_RaiseIntensity:
LDR	LR, [SP, #0]
ADD	SP, SP, #12
BX	LR
; end of _RaiseIntensity
_Shutdown:
;LED_Driver.c,226 :: 		void Shutdown(void) {
SUB	SP, SP, #12
STR	LR, [SP, #0]
;LED_Driver.c,230 :: 		Hi(CmdDat) = CONFIGURATION;
ADD	R2, SP, #8
ADDS	R1, R2, #1
MOVS	R0, #4
STRB	R0, [R1, #0]
;LED_Driver.c,231 :: 		Configuration &= 0xFE;                      // Turn off S bit
MOVW	R1, #lo_addr(_Configuration+0)
MOVT	R1, #hi_addr(_Configuration+0)
LDRB	R0, [R1, #0]
AND	R0, R0, #254
STRB	R0, [R1, #0]
;LED_Driver.c,232 :: 		Lo(CmdDat) = Configuration;
STRB	R0, [R2, #0]
;LED_Driver.c,233 :: 		Display_Write(CmdDat);
LDRH	R0, [SP, #8]
BL	_Display_Write+0
;LED_Driver.c,236 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
; BufNum start address is: 12 (R3)
MOV	R3, R0
;LED_Driver.c,237 :: 		sprintf(BufNum,"Configuration: %02X",Configuration);
MOVW	R1, #lo_addr(_Configuration+0)
MOVT	R1, #hi_addr(_Configuration+0)
LDRB	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_6_LED_Driver+0)
MOVT	R1, #hi_addr(?lstr_6_LED_Driver+0)
STR	R3, [SP, #4]
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #12
LDR	R3, [SP, #4]
;LED_Driver.c,238 :: 		USB_PutQueue(BufNum);
MOV	R0, R3
; BufNum end address is: 12 (R3)
BL	_USB_PutQueue+0
;LED_Driver.c,239 :: 		}
L_end_Shutdown:
LDR	LR, [SP, #0]
ADD	SP, SP, #12
BX	LR
; end of _Shutdown
_Normal:
;LED_Driver.c,241 :: 		void Normal(void) {
SUB	SP, SP, #12
STR	LR, [SP, #0]
;LED_Driver.c,245 :: 		Hi(CmdDat) = CONFIGURATION;
ADD	R2, SP, #8
ADDS	R1, R2, #1
MOVS	R0, #4
STRB	R0, [R1, #0]
;LED_Driver.c,246 :: 		Configuration |= 0x01;                      // Turn on S bit
MOVW	R1, #lo_addr(_Configuration+0)
MOVT	R1, #hi_addr(_Configuration+0)
LDRB	R0, [R1, #0]
ORR	R0, R0, #1
STRB	R0, [R1, #0]
;LED_Driver.c,247 :: 		Lo(CmdDat) = Configuration;
STRB	R0, [R2, #0]
;LED_Driver.c,248 :: 		Display_Write(CmdDat);
LDRH	R0, [SP, #8]
BL	_Display_Write+0
;LED_Driver.c,251 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
; BufNum start address is: 12 (R3)
MOV	R3, R0
;LED_Driver.c,252 :: 		sprintf(BufNum,"Configuration: %02X",Configuration);
MOVW	R1, #lo_addr(_Configuration+0)
MOVT	R1, #hi_addr(_Configuration+0)
LDRB	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_7_LED_Driver+0)
MOVT	R1, #hi_addr(?lstr_7_LED_Driver+0)
STR	R3, [SP, #4]
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #12
LDR	R3, [SP, #4]
;LED_Driver.c,253 :: 		USB_PutQueue(BufNum);
MOV	R0, R3
; BufNum end address is: 12 (R3)
BL	_USB_PutQueue+0
;LED_Driver.c,254 :: 		}
L_end_Normal:
LDR	LR, [SP, #0]
ADD	SP, SP, #12
BX	LR
; end of _Normal
_BlinkSlow:
;LED_Driver.c,256 :: 		void BlinkSlow(void) {
SUB	SP, SP, #12
STR	LR, [SP, #0]
;LED_Driver.c,260 :: 		Hi(CmdDat) = CONFIGURATION;
ADD	R2, SP, #8
ADDS	R1, R2, #1
MOVS	R0, #4
STRB	R0, [R1, #0]
;LED_Driver.c,261 :: 		Configuration &= 0xFB;                      // Turn off B bit (Bin: 1 1 1 1  1 0 1 1)
MOVW	R1, #lo_addr(_Configuration+0)
MOVT	R1, #hi_addr(_Configuration+0)
LDRB	R0, [R1, #0]
AND	R0, R0, #251
UXTB	R0, R0
STRB	R0, [R1, #0]
;LED_Driver.c,262 :: 		Configuration |= 0x08;                      // Turn on E bit  (Bin: 0 0 0 0  1 0 0 0)
ORR	R0, R0, #8
STRB	R0, [R1, #0]
;LED_Driver.c,263 :: 		Lo(CmdDat) = Configuration;
STRB	R0, [R2, #0]
;LED_Driver.c,264 :: 		Display_Write(CmdDat);
LDRH	R0, [SP, #8]
BL	_Display_Write+0
;LED_Driver.c,267 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
; BufNum start address is: 12 (R3)
MOV	R3, R0
;LED_Driver.c,268 :: 		sprintf(BufNum,"Configuration: %02X",Configuration);
MOVW	R1, #lo_addr(_Configuration+0)
MOVT	R1, #hi_addr(_Configuration+0)
LDRB	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_8_LED_Driver+0)
MOVT	R1, #hi_addr(?lstr_8_LED_Driver+0)
STR	R3, [SP, #4]
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #12
LDR	R3, [SP, #4]
;LED_Driver.c,269 :: 		USB_PutQueue(BufNum);
MOV	R0, R3
; BufNum end address is: 12 (R3)
BL	_USB_PutQueue+0
;LED_Driver.c,270 :: 		}
L_end_BlinkSlow:
LDR	LR, [SP, #0]
ADD	SP, SP, #12
BX	LR
; end of _BlinkSlow
_BlinkFast:
;LED_Driver.c,272 :: 		void BlinkFast(void) {
SUB	SP, SP, #12
STR	LR, [SP, #0]
;LED_Driver.c,276 :: 		Hi(CmdDat) = CONFIGURATION;
ADD	R2, SP, #8
ADDS	R1, R2, #1
MOVS	R0, #4
STRB	R0, [R1, #0]
;LED_Driver.c,277 :: 		Configuration |= 0x0C;                      // Turn on B bit and E bit
MOVW	R1, #lo_addr(_Configuration+0)
MOVT	R1, #hi_addr(_Configuration+0)
LDRB	R0, [R1, #0]
ORR	R0, R0, #12
STRB	R0, [R1, #0]
;LED_Driver.c,278 :: 		Lo(CmdDat) = Configuration;                 // (Bin: 0 0 0 0  1 1 0 0)
STRB	R0, [R2, #0]
;LED_Driver.c,279 :: 		Display_Write(CmdDat);
LDRH	R0, [SP, #8]
BL	_Display_Write+0
;LED_Driver.c,282 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
; BufNum start address is: 12 (R3)
MOV	R3, R0
;LED_Driver.c,283 :: 		sprintf(BufNum,"Configuration: %02X",Configuration);
MOVW	R1, #lo_addr(_Configuration+0)
MOVT	R1, #hi_addr(_Configuration+0)
LDRB	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_9_LED_Driver+0)
MOVT	R1, #hi_addr(?lstr_9_LED_Driver+0)
STR	R3, [SP, #4]
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #12
LDR	R3, [SP, #4]
;LED_Driver.c,284 :: 		USB_PutQueue(BufNum);
MOV	R0, R3
; BufNum end address is: 12 (R3)
BL	_USB_PutQueue+0
;LED_Driver.c,285 :: 		}
L_end_BlinkFast:
LDR	LR, [SP, #0]
ADD	SP, SP, #12
BX	LR
; end of _BlinkFast
_BlinkOff:
;LED_Driver.c,287 :: 		void BlinkOff(void) {
SUB	SP, SP, #12
STR	LR, [SP, #0]
;LED_Driver.c,291 :: 		Hi(CmdDat) = CONFIGURATION;
ADD	R2, SP, #8
ADDS	R1, R2, #1
MOVS	R0, #4
STRB	R0, [R1, #0]
;LED_Driver.c,293 :: 		Configuration &= 0xFD;                      // Turn off E bit (Bin: 1 1 1 1  1 1 0 1)
MOVW	R1, #lo_addr(_Configuration+0)
MOVT	R1, #hi_addr(_Configuration+0)
LDRB	R0, [R1, #0]
AND	R0, R0, #253
STRB	R0, [R1, #0]
;LED_Driver.c,294 :: 		Lo(CmdDat) = Configuration;
STRB	R0, [R2, #0]
;LED_Driver.c,295 :: 		Display_Write(CmdDat);
LDRH	R0, [SP, #8]
BL	_Display_Write+0
;LED_Driver.c,298 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
; BufNum start address is: 12 (R3)
MOV	R3, R0
;LED_Driver.c,299 :: 		sprintf(BufNum,"Configuration: %02X",Configuration);
MOVW	R1, #lo_addr(_Configuration+0)
MOVT	R1, #hi_addr(_Configuration+0)
LDRB	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_10_LED_Driver+0)
MOVT	R1, #hi_addr(?lstr_10_LED_Driver+0)
STR	R3, [SP, #4]
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #12
LDR	R3, [SP, #4]
;LED_Driver.c,300 :: 		USB_PutQueue(BufNum);
MOV	R0, R3
; BufNum end address is: 12 (R3)
BL	_USB_PutQueue+0
;LED_Driver.c,301 :: 		}
L_end_BlinkOff:
LDR	LR, [SP, #0]
ADD	SP, SP, #12
BX	LR
; end of _BlinkOff
_Test:
;LED_Driver.c,303 :: 		void Test(char Mask) {
; Mask start address is: 0 (R0)
SUB	SP, SP, #12
STR	LR, [SP, #0]
; Mask end address is: 0 (R0)
; Mask start address is: 0 (R0)
;LED_Driver.c,307 :: 		Hi(CmdDat) = CONFIGURATION;
ADD	R3, SP, #8
ADDS	R2, R3, #1
MOVS	R1, #4
STRB	R1, [R2, #0]
;LED_Driver.c,308 :: 		Configuration = Mask;                       // Set Configuration reg according to mask
MOVW	R1, #lo_addr(_Configuration+0)
MOVT	R1, #hi_addr(_Configuration+0)
STRB	R0, [R1, #0]
;LED_Driver.c,309 :: 		Lo(CmdDat) = Configuration;
STRB	R0, [R3, #0]
; Mask end address is: 0 (R0)
;LED_Driver.c,310 :: 		Display_Write(CmdDat);
LDRH	R0, [SP, #8]
BL	_Display_Write+0
;LED_Driver.c,313 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
; BufNum start address is: 16 (R4)
MOV	R4, R0
;LED_Driver.c,314 :: 		sprintf(BufNum,"Configuration: %02X",Configuration);
MOVW	R1, #lo_addr(_Configuration+0)
MOVT	R1, #hi_addr(_Configuration+0)
LDRB	R3, [R1, #0]
MOVW	R2, #lo_addr(?lstr_11_LED_Driver+0)
MOVT	R2, #hi_addr(?lstr_11_LED_Driver+0)
MOV	R1, R0
STR	R4, [SP, #4]
PUSH	(R3)
PUSH	(R2)
PUSH	(R1)
BL	_sprintf+0
ADD	SP, SP, #12
LDR	R4, [SP, #4]
;LED_Driver.c,315 :: 		USB_PutQueue(BufNum);
MOV	R0, R4
; BufNum end address is: 16 (R4)
BL	_USB_PutQueue+0
;LED_Driver.c,316 :: 		}
L_end_Test:
LDR	LR, [SP, #0]
ADD	SP, SP, #12
BX	LR
; end of _Test
_Increment:
;LED_Driver.c,318 :: 		void Increment(void) {
SUB	SP, SP, #12
STR	LR, [SP, #0]
;LED_Driver.c,322 :: 		Hi(CmdDat) = CONFIGURATION;
ADD	R2, SP, #8
ADDS	R1, R2, #1
MOVS	R0, #4
STRB	R0, [R1, #0]
;LED_Driver.c,323 :: 		Configuration += 1;                         // Increment Configuration
MOVW	R1, #lo_addr(_Configuration+0)
MOVT	R1, #hi_addr(_Configuration+0)
LDRB	R0, [R1, #0]
ADDS	R0, R0, #1
STRB	R0, [R1, #0]
;LED_Driver.c,324 :: 		Lo(CmdDat) = Configuration;
UXTB	R0, R0
STRB	R0, [R2, #0]
;LED_Driver.c,325 :: 		Display_Write(CmdDat);
LDRH	R0, [SP, #8]
BL	_Display_Write+0
;LED_Driver.c,328 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
; BufNum start address is: 12 (R3)
MOV	R3, R0
;LED_Driver.c,329 :: 		sprintf(BufNum,"Configuration: %02X",Configuration);
MOVW	R1, #lo_addr(_Configuration+0)
MOVT	R1, #hi_addr(_Configuration+0)
LDRB	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_12_LED_Driver+0)
MOVT	R1, #hi_addr(?lstr_12_LED_Driver+0)
STR	R3, [SP, #4]
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #12
LDR	R3, [SP, #4]
;LED_Driver.c,330 :: 		USB_PutQueue(BufNum);
MOV	R0, R3
; BufNum end address is: 12 (R3)
BL	_USB_PutQueue+0
;LED_Driver.c,331 :: 		}
L_end_Increment:
LDR	LR, [SP, #0]
ADD	SP, SP, #12
BX	LR
; end of _Increment
_DispTest:
;LED_Driver.c,333 :: 		void DispTest(char OnOff) {
; OnOff start address is: 0 (R0)
SUB	SP, SP, #8
STR	LR, [SP, #0]
; OnOff end address is: 0 (R0)
; OnOff start address is: 0 (R0)
;LED_Driver.c,336 :: 		Hi(CmdDat) = DISPLAY_TEST;
ADD	R3, SP, #4
ADDS	R2, R3, #1
MOVS	R1, #7
STRB	R1, [R2, #0]
;LED_Driver.c,337 :: 		Lo(CmdDat) = OnOff;
STRB	R0, [R3, #0]
; OnOff end address is: 0 (R0)
;LED_Driver.c,338 :: 		Display_Write(CmdDat);
LDRH	R0, [SP, #4]
BL	_Display_Write+0
;LED_Driver.c,339 :: 		}
L_end_DispTest:
LDR	LR, [SP, #0]
ADD	SP, SP, #8
BX	LR
; end of _DispTest
