#line 1 "C:/ARM Projects/Mikromedia for STM32 M4/LED Display Driver/Code/LED_Main.c"
#line 1 "c:/arm projects/mikromedia for stm32 m4/led display driver/code/usb_driver.h"
#line 11 "c:/arm projects/mikromedia for stm32 m4/led display driver/code/usb_driver.h"
typedef char *pnt;


typedef struct USB_TxStruct {
 unsigned int in;
 unsigned int out;
 pnt q[ 32 ];
}USB_TxStruct;



void USB_Init(void);
void USB_TxQueueInit(void);
void USB_PutQueue(char *msg);
void USB_CheckOut(void);
void USB_CheckIn(void);
#line 1 "c:/arm projects/mikromedia for stm32 m4/led display driver/code/timers.h"
#line 9 "c:/arm projects/mikromedia for stm32 m4/led display driver/code/timers.h"
void Timer_Init();
void TimerCheck();
#line 31 "c:/arm projects/mikromedia for stm32 m4/led display driver/code/timers.h"
struct timers {
 unsigned long int TimerField;
 unsigned short int Free;
};
#line 43 "c:/arm projects/mikromedia for stm32 m4/led display driver/code/timers.h"
void init_timerpool(void);
#line 52 "c:/arm projects/mikromedia for stm32 m4/led display driver/code/timers.h"
unsigned short int get_timer(void);
#line 61 "c:/arm projects/mikromedia for stm32 m4/led display driver/code/timers.h"
void free_timer(unsigned short int nbr);
#line 71 "c:/arm projects/mikromedia for stm32 m4/led display driver/code/timers.h"
void set_timer(unsigned short int nbr, unsigned long int tout);
#line 80 "c:/arm projects/mikromedia for stm32 m4/led display driver/code/timers.h"
unsigned long int check_timer(unsigned short int nbr);
#line 89 "c:/arm projects/mikromedia for stm32 m4/led display driver/code/timers.h"
void irqhandler_timer(void);
#line 1 "c:/arm projects/mikromedia for stm32 m4/led display driver/code/led_driver.h"
#line 25 "c:/arm projects/mikromedia for stm32 m4/led display driver/code/led_driver.h"
void Display_Init(void);
void Display_Write(unsigned _data);
void Display_Setup(void);
char DisplayAll(char *Msg);
void SetDigit(char Digit, char _data, char DecPt);
void SetDecodeReg(char Mask);
void LowerIntensity(void);
void RaiseIntensity(void);

void Shutdown(void);
void Normal(void);
void BlinkSlow(void);
void BlinkFast(void);
void BlinkOff(void);

void Test(char Mask);
void Increment(void);
void DispTest(char OnOff);
#line 1 "c:/arm projects/mikromedia for stm32 m4/led display driver/code/tft_driver.h"
#line 8 "c:/arm projects/mikromedia for stm32 m4/led display driver/code/tft_driver.h"
void Init_MCU(void);
void DrawScr(void);
void Init_TouchPanel(void);
void Start_TP(void);
#line 29 "C:/ARM Projects/Mikromedia for STM32 M4/LED Display Driver/Code/LED_Main.c"
unsigned short int MainTimer;





void main() {

 USB_Init();

 Timer_Init();
 MainTimer = get_timer();
 set_timer(MainTimer,2000);


 while (check_timer(MainTimer) != 0) {
 }
 USB_PutQueue(" ");
 USB_PutQueue("LED display program started");

 Display_Init();
 Start_TP();
 EnableInterrupts();


 while (1) {

 USB_CheckIn();
 USB_CheckOut();

 TimerCheck();
 }
}
