_Init_MCU:
;TFT_Driver.c,29 :: 		void Init_MCU() {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;TFT_Driver.c,31 :: 		GPIO_Config(&GPIOE_BASE, _GPIO_PINMASK_9, _GPIO_CFG_DIGITAL_OUTPUT);
MOVW	R2, #20
MOVT	R2, #8
MOVW	R1, #512
MOVW	R0, #lo_addr(GPIOE_BASE+0)
MOVT	R0, #hi_addr(GPIOE_BASE+0)
BL	_GPIO_Config+0
;TFT_Driver.c,32 :: 		TFT_BLED = 1;
MOVS	R1, #1
SXTB	R1, R1
MOVW	R0, #lo_addr(GPIOE_ODR+0)
MOVT	R0, #hi_addr(GPIOE_ODR+0)
STR	R1, [R0, #0]
;TFT_Driver.c,33 :: 		TFT_Set_Default_Mode();
BL	_TFT_Set_Default_Mode+0
;TFT_Driver.c,34 :: 		TFT_Init_ILI9341_8bit(320, 240);
MOVS	R1, #240
MOVW	R0, #320
BL	_TFT_Init_ILI9341_8bit+0
;TFT_Driver.c,38 :: 		}
L_end_Init_MCU:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _Init_MCU
_DrawScr:
;TFT_Driver.c,43 :: 		void DrawScr(void) {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;TFT_Driver.c,44 :: 		TFT_Fill_Screen(CL_WHITE);
MOVW	R0, #65535
BL	_TFT_Fill_Screen+0
;TFT_Driver.c,45 :: 		TFT_Set_Pen(CL_Black, 1);
MOVS	R1, #1
MOVW	R0, #0
BL	_TFT_Set_Pen+0
;TFT_Driver.c,46 :: 		TFT_Line(20, 220, 300, 220);
MOVS	R3, #220
SXTH	R3, R3
MOVW	R2, #300
SXTH	R2, R2
MOVS	R1, #220
SXTH	R1, R1
MOVS	R0, #20
SXTH	R0, R0
BL	_TFT_Line+0
;TFT_Driver.c,47 :: 		TFT_LIne(20,  46, 300,  46);
MOVS	R3, #46
SXTH	R3, R3
MOVW	R2, #300
SXTH	R2, R2
MOVS	R1, #46
SXTH	R1, R1
MOVS	R0, #20
SXTH	R0, R0
BL	_TFT_Line+0
;TFT_Driver.c,48 :: 		TFT_Set_Font(&HandelGothic_BT21x22_Regular, CL_RED, FO_HORIZONTAL);
MOVS	R2, #0
MOVW	R1, #63488
MOVW	R0, #lo_addr(_HandelGothic_BT21x22_Regular+0)
MOVT	R0, #hi_addr(_HandelGothic_BT21x22_Regular+0)
BL	_TFT_Set_Font+0
;TFT_Driver.c,49 :: 		TFT_Write_Text("LCD     DISPLAY", 90, 14);
MOVW	R0, #lo_addr(?lstr1_TFT_Driver+0)
MOVT	R0, #hi_addr(?lstr1_TFT_Driver+0)
MOVS	R2, #14
MOVS	R1, #90
BL	_TFT_Write_Text+0
;TFT_Driver.c,50 :: 		TFT_Set_Font(&Verdana12x13_Regular, CL_BLACK, FO_HORIZONTAL);
MOVS	R2, #0
MOVW	R1, #0
MOVW	R0, #lo_addr(_Verdana12x13_Regular+0)
MOVT	R0, #hi_addr(_Verdana12x13_Regular+0)
BL	_TFT_Set_Font+0
;TFT_Driver.c,51 :: 		TFT_Write_Text("mikromedia for STM32 M4", 20, 223);
MOVW	R0, #lo_addr(?lstr2_TFT_Driver+0)
MOVT	R0, #hi_addr(?lstr2_TFT_Driver+0)
MOVS	R2, #223
MOVS	R1, #20
BL	_TFT_Write_Text+0
;TFT_Driver.c,52 :: 		TFT_Set_Font(&Verdana12x13_Regular, CL_RED, FO_HORIZONTAL);
MOVS	R2, #0
MOVW	R1, #63488
MOVW	R0, #lo_addr(_Verdana12x13_Regular+0)
MOVT	R0, #hi_addr(_Verdana12x13_Regular+0)
BL	_TFT_Set_Font+0
;TFT_Driver.c,53 :: 		TFT_Write_Text("Val Gretchev", 220, 223);
MOVW	R0, #lo_addr(?lstr3_TFT_Driver+0)
MOVT	R0, #hi_addr(?lstr3_TFT_Driver+0)
MOVS	R2, #223
MOVS	R1, #220
BL	_TFT_Write_Text+0
;TFT_Driver.c,54 :: 		TFT_Set_Font(&TFT_defaultFont, CL_BLACK, FO_HORIZONTAL);
MOVS	R2, #0
MOVW	R1, #0
MOVW	R0, #lo_addr(_TFT_defaultFont+0)
MOVT	R0, #hi_addr(_TFT_defaultFont+0)
BL	_TFT_Set_Font+0
;TFT_Driver.c,55 :: 		TFT_Set_Font(&Tahoma130x160_Regular, CL_GREEN, FO_HORIZONTAL);
MOVS	R2, #0
MOVW	R1, #1024
MOVW	R0, #lo_addr(_Tahoma130x160_Regular+0)
MOVT	R0, #hi_addr(_Tahoma130x160_Regular+0)
BL	_TFT_Set_Font+0
;TFT_Driver.c,56 :: 		TFT_Write_Text("0000", 20, 30);
MOVW	R0, #lo_addr(?lstr4_TFT_Driver+0)
MOVT	R0, #hi_addr(?lstr4_TFT_Driver+0)
MOVS	R2, #30
MOVS	R1, #20
BL	_TFT_Write_Text+0
;TFT_Driver.c,57 :: 		}
L_end_DrawScr:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _DrawScr
_Init_TouchPanel:
;TFT_Driver.c,62 :: 		void Init_TouchPanel(void) {
;TFT_Driver.c,65 :: 		}
L_end_Init_TouchPanel:
BX	LR
; end of _Init_TouchPanel
_Start_TP:
;TFT_Driver.c,70 :: 		void Start_TP(void) {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;TFT_Driver.c,71 :: 		Init_MCU();
BL	_Init_MCU+0
;TFT_Driver.c,72 :: 		DrawScr();
BL	_DrawScr+0
;TFT_Driver.c,75 :: 		}
L_end_Start_TP:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _Start_TP
