#line 1 "C:/ARM Projects/Mikromedia for STM32 M4/LED Display Driver/Code/Timers.c"
#line 1 "c:/arm projects/mikromedia for stm32 m4/led display driver/code/timers.h"
#line 9 "c:/arm projects/mikromedia for stm32 m4/led display driver/code/timers.h"
void Timer_Init();
void TimerCheck();
#line 31 "c:/arm projects/mikromedia for stm32 m4/led display driver/code/timers.h"
struct timers {
 unsigned long int TimerField;
 unsigned short int Free;
};
#line 43 "c:/arm projects/mikromedia for stm32 m4/led display driver/code/timers.h"
void init_timerpool(void);
#line 52 "c:/arm projects/mikromedia for stm32 m4/led display driver/code/timers.h"
unsigned short int get_timer(void);
#line 61 "c:/arm projects/mikromedia for stm32 m4/led display driver/code/timers.h"
void free_timer(unsigned short int nbr);
#line 71 "c:/arm projects/mikromedia for stm32 m4/led display driver/code/timers.h"
void set_timer(unsigned short int nbr, unsigned long int tout);
#line 80 "c:/arm projects/mikromedia for stm32 m4/led display driver/code/timers.h"
unsigned long int check_timer(unsigned short int nbr);
#line 89 "c:/arm projects/mikromedia for stm32 m4/led display driver/code/timers.h"
void irqhandler_timer(void);
#line 1 "c:/arm projects/mikromedia for stm32 m4/led display driver/code/common.h"
#line 1 "c:/arm projects/mikromedia for stm32 m4/led display driver/code/usb_driver.h"
#line 11 "c:/arm projects/mikromedia for stm32 m4/led display driver/code/usb_driver.h"
typedef char *pnt;


typedef struct USB_TxStruct {
 unsigned int in;
 unsigned int out;
 pnt q[ 32 ];
}USB_TxStruct;



void USB_Init(void);
void USB_TxQueueInit(void);
void USB_PutQueue(char *msg);
void USB_CheckOut(void);
void USB_CheckIn(void);
#line 10 "C:/ARM Projects/Mikromedia for STM32 M4/LED Display Driver/Code/Timers.c"
int TimerFlag = 0;
unsigned int Msec = 0;
#line 23 "C:/ARM Projects/Mikromedia for STM32 M4/LED Display Driver/Code/Timers.c"
void SystemTimerInterrupt() iv IVT_INT_SysTick ics ICS_AUTO {
 if (COUNTFLAG_bit) {
 irqhandler_timer();

 Msec += 1;
 if (Msec > 999) {
 Msec = 0;
 TimerFlag = 1;
 }
 }
}
#line 38 "C:/ARM Projects/Mikromedia for STM32 M4/LED Display Driver/Code/Timers.c"
void Timer_Init() {
 init_timerpool();


 NVIC_SYSTICKRVR = 15000;
 NVIC_SYSTICKCVR = 0;
 ENABLE_SYSTICKCSR_bit = 1;
 TICKINT_bit = 1;
}
#line 51 "C:/ARM Projects/Mikromedia for STM32 M4/LED Display Driver/Code/Timers.c"
void TimerCheck() {
 if (TimerFlag == 1) {
 TimerFlag = 0;


 }
}
#line 80 "C:/ARM Projects/Mikromedia for STM32 M4/LED Display Driver/Code/Timers.c"
struct timers TimerPool[ 10 ];
#line 89 "C:/ARM Projects/Mikromedia for STM32 M4/LED Display Driver/Code/Timers.c"
void init_timerpool(void) {
 unsigned short int i;

 for (i=0; i <  10 ; i++) {
 TimerPool[i].TimerField = 0;
 TimerPool[i].Free =  1 ;
 }
}
#line 104 "C:/ARM Projects/Mikromedia for STM32 M4/LED Display Driver/Code/Timers.c"
unsigned short int get_timer(void) {
 unsigned short int i;

 for (i=0; i <  10 ; i++) {
 if (TimerPool[i].Free ==  1 ) {
 TimerPool[i].Free =  0 ;
 return i;
 }
 }


 USB_PutQueue("TIMERS: No Timers, Resetting..\r\n");
 SystemReset();
 return (0);
}
#line 126 "C:/ARM Projects/Mikromedia for STM32 M4/LED Display Driver/Code/Timers.c"
void free_timer(unsigned short int nbr) {
 if (nbr > ( 10 -1))
 return;

 TimerPool[nbr].Free =  1 ;
}
#line 140 "C:/ARM Projects/Mikromedia for STM32 M4/LED Display Driver/Code/Timers.c"
void set_timer(unsigned short int nbr, unsigned long int tout) {
 if (nbr > ( 10 -1))
 return;

 if (TimerPool[nbr].Free ==  1 )
 return;

 TimerPool[nbr].TimerField = tout;
}
#line 156 "C:/ARM Projects/Mikromedia for STM32 M4/LED Display Driver/Code/Timers.c"
unsigned long int check_timer(unsigned short int nbr) {
 return TimerPool[nbr].TimerField;
}
#line 166 "C:/ARM Projects/Mikromedia for STM32 M4/LED Display Driver/Code/Timers.c"
void irqhandler_timer(void) {
 unsigned short int i;

 for (i=0; i< 10 ; i++) {
 if (TimerPool[i].Free ==  0  && TimerPool[i].TimerField != 0)
 TimerPool[i].TimerField--;
 }
}
