_USBInterrupt:
;USB_Driver.c,23 :: 		void USBInterrupt() iv IVT_INT_OTG_FS ics ICS_AUTO {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;USB_Driver.c,24 :: 		USB_Interrupt_Proc();
BL	_USB_Interrupt_Proc+0
;USB_Driver.c,25 :: 		}
L_end_USBInterrupt:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _USBInterrupt
_USB_Init:
;USB_Driver.c,30 :: 		void USB_Init(void) {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;USB_Driver.c,34 :: 		HID_Enable(&readbuff,&writebuff);
MOVW	R1, #lo_addr(_writebuff+0)
MOVT	R1, #hi_addr(_writebuff+0)
MOVW	R0, #lo_addr(_readbuff+0)
MOVT	R0, #hi_addr(_readbuff+0)
BL	_HID_Enable+0
;USB_Driver.c,35 :: 		USB_TxQueueInit();
BL	_USB_TxQueueInit+0
;USB_Driver.c,37 :: 		}
L_end_USB_Init:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _USB_Init
_USB_TxQueueInit:
;USB_Driver.c,42 :: 		void USB_TxQueueInit(void) {
;USB_Driver.c,44 :: 		USB_Queue.in = 0;
MOVS	R1, #0
MOVW	R0, #lo_addr(_USB_Queue+0)
MOVT	R0, #hi_addr(_USB_Queue+0)
STRH	R1, [R0, #0]
;USB_Driver.c,45 :: 		USB_Queue.out = 0;
MOVS	R1, #0
MOVW	R0, #lo_addr(_USB_Queue+2)
MOVT	R0, #hi_addr(_USB_Queue+2)
STRH	R1, [R0, #0]
;USB_Driver.c,46 :: 		}
L_end_USB_TxQueueInit:
BX	LR
; end of _USB_TxQueueInit
_USB_PutQueue:
;USB_Driver.c,52 :: 		void USB_PutQueue(char *msg) {
; msg start address is: 0 (R0)
; msg end address is: 0 (R0)
; msg start address is: 0 (R0)
;USB_Driver.c,54 :: 		USB_Queue.q[USB_Queue.in++] = msg;
MOVW	R3, #lo_addr(_USB_Queue+0)
MOVT	R3, #hi_addr(_USB_Queue+0)
LDRH	R1, [R3, #0]
LSLS	R2, R1, #2
MOVW	R1, #lo_addr(_USB_Queue+4)
MOVT	R1, #hi_addr(_USB_Queue+4)
ADDS	R1, R1, R2
STR	R0, [R1, #0]
; msg end address is: 0 (R0)
MOV	R1, R3
LDRH	R1, [R1, #0]
ADDS	R1, R1, #1
UXTH	R1, R1
STRH	R1, [R3, #0]
;USB_Driver.c,55 :: 		if (USB_Queue.in > (USB_Queue_Size-1))
CMP	R1, #31
IT	LS
BLS	L_USB_PutQueue0
;USB_Driver.c,56 :: 		USB_Queue.in = 0;
MOVS	R2, #0
MOVW	R1, #lo_addr(_USB_Queue+0)
MOVT	R1, #hi_addr(_USB_Queue+0)
STRH	R2, [R1, #0]
L_USB_PutQueue0:
;USB_Driver.c,57 :: 		}
L_end_USB_PutQueue:
BX	LR
; end of _USB_PutQueue
_USB_CheckOut:
;USB_Driver.c,65 :: 		void USB_CheckOut(void) {
SUB	SP, SP, #4
STR	LR, [SP, #0]
;USB_Driver.c,67 :: 		if (USB_Queue.in != USB_Queue.out) {          // Look for a pointer in the FIFO
MOVW	R0, #lo_addr(_USB_Queue+2)
MOVT	R0, #hi_addr(_USB_Queue+2)
LDRH	R1, [R0, #0]
MOVW	R0, #lo_addr(_USB_Queue+0)
MOVT	R0, #hi_addr(_USB_Queue+0)
LDRH	R0, [R0, #0]
CMP	R0, R1
IT	EQ
BEQ	L_USB_CheckOut1
;USB_Driver.c,70 :: 		if (HID_Write(USB_Queue.q[USB_Queue.out],64) != 0) {
MOVW	R0, #lo_addr(_USB_Queue+2)
MOVT	R0, #hi_addr(_USB_Queue+2)
LDRH	R0, [R0, #0]
LSLS	R1, R0, #2
MOVW	R0, #lo_addr(_USB_Queue+4)
MOVT	R0, #hi_addr(_USB_Queue+4)
ADDS	R0, R0, R1
LDR	R0, [R0, #0]
MOVS	R1, #64
BL	_HID_Write+0
CMP	R0, #0
IT	EQ
BEQ	L_USB_CheckOut2
;USB_Driver.c,71 :: 		USB_Queue.out++;
MOVW	R1, #lo_addr(_USB_Queue+2)
MOVT	R1, #hi_addr(_USB_Queue+2)
LDRH	R0, [R1, #0]
ADDS	R0, R0, #1
UXTH	R0, R0
STRH	R0, [R1, #0]
;USB_Driver.c,72 :: 		if (USB_Queue.out > (USB_Queue_Size-1))  // If past the end of array
CMP	R0, #31
IT	LS
BLS	L_USB_CheckOut3
;USB_Driver.c,73 :: 		USB_Queue.out = 0;                   // set pointer to start of array
MOVS	R1, #0
MOVW	R0, #lo_addr(_USB_Queue+2)
MOVT	R0, #hi_addr(_USB_Queue+2)
STRH	R1, [R0, #0]
L_USB_CheckOut3:
;USB_Driver.c,74 :: 		}
L_USB_CheckOut2:
;USB_Driver.c,75 :: 		}
L_USB_CheckOut1:
;USB_Driver.c,76 :: 		}
L_end_USB_CheckOut:
LDR	LR, [SP, #0]
ADD	SP, SP, #4
BX	LR
; end of _USB_CheckOut
_USB_CheckIn:
;USB_Driver.c,83 :: 		void USB_CheckIn(void) {
SUB	SP, SP, #8
STR	LR, [SP, #0]
;USB_Driver.c,87 :: 		if (HID_Read() != 0) {
BL	_HID_Read+0
CMP	R0, #0
IT	EQ
BEQ	L_USB_CheckIn4
;USB_Driver.c,88 :: 		switch (readbuff[0]) {
IT	AL
BAL	L_USB_CheckIn5
;USB_Driver.c,90 :: 		case 'a':  // Diagnostic test of USB
L_USB_CheckIn7:
;USB_Driver.c,91 :: 		BufNum = GetBuffer();
BL	_GetBuffer+0
; BufNum start address is: 8 (R2)
MOV	R2, R0
;USB_Driver.c,92 :: 		sprintf(BufNum,"Command 'a' received");
MOVW	R1, #lo_addr(?lstr_1_USB_Driver+0)
MOVT	R1, #hi_addr(?lstr_1_USB_Driver+0)
STR	R2, [SP, #4]
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #8
LDR	R2, [SP, #4]
;USB_Driver.c,93 :: 		USB_PutQueue(BufNum);
MOV	R0, R2
; BufNum end address is: 8 (R2)
BL	_USB_PutQueue+0
;USB_Driver.c,94 :: 		break;
IT	AL
BAL	L_USB_CheckIn6
;USB_Driver.c,95 :: 		case 'b':  // Another diagnostic test
L_USB_CheckIn8:
;USB_Driver.c,96 :: 		USB_PutQueue("Command 'b' received");
MOVW	R0, #lo_addr(?lstr2_USB_Driver+0)
MOVT	R0, #hi_addr(?lstr2_USB_Driver+0)
BL	_USB_PutQueue+0
;USB_Driver.c,97 :: 		break;
IT	AL
BAL	L_USB_CheckIn6
;USB_Driver.c,98 :: 		case 'c':  // This only works becuse the high order nibble is ignored by MAX6951
L_USB_CheckIn9:
;USB_Driver.c,99 :: 		DisplayAll(&TempBuf);
MOVW	R0, #lo_addr(_TempBuf+0)
MOVT	R0, #hi_addr(_TempBuf+0)
BL	_DisplayAll+0
;USB_Driver.c,100 :: 		break;
IT	AL
BAL	L_USB_CheckIn6
;USB_Driver.c,101 :: 		case 'd':  // Display hex character A in digit 0
L_USB_CheckIn10:
;USB_Driver.c,102 :: 		SetDigit(0,0x0A,0); // Try changing digits and hex character
MOVS	R2, #0
MOVS	R1, #10
MOVS	R0, #0
BL	_SetDigit+0
;USB_Driver.c,103 :: 		break;
IT	AL
BAL	L_USB_CheckIn6
;USB_Driver.c,104 :: 		case 'e':  // Blank digit 0
L_USB_CheckIn11:
;USB_Driver.c,105 :: 		SetDigit(0,0x00,0); // The digit code has to be 0
MOVS	R2, #0
MOVS	R1, #0
MOVS	R0, #0
BL	_SetDigit+0
;USB_Driver.c,106 :: 		SetDecodeReg(0xFE); // then bit 0 of Decode Reg can be turned off
MOVS	R0, #254
BL	_SetDecodeReg+0
;USB_Driver.c,107 :: 		break;
IT	AL
BAL	L_USB_CheckIn6
;USB_Driver.c,108 :: 		case 'f':  // Step intensity lower
L_USB_CheckIn12:
;USB_Driver.c,109 :: 		LowerIntensity(); // The steps will decrease until at 0
BL	_LowerIntensity+0
;USB_Driver.c,110 :: 		break;
IT	AL
BAL	L_USB_CheckIn6
;USB_Driver.c,111 :: 		case 'g':  // Step intensity higher
L_USB_CheckIn13:
;USB_Driver.c,112 :: 		RaiseIntensity(); // The steps will increase until at 15
BL	_RaiseIntensity+0
;USB_Driver.c,113 :: 		break;
IT	AL
BAL	L_USB_CheckIn6
;USB_Driver.c,114 :: 		case 'h':  // Put display in low power mode
L_USB_CheckIn14:
;USB_Driver.c,115 :: 		Shutdown(); // The display goes
BL	_Shutdown+0
;USB_Driver.c,116 :: 		break;
IT	AL
BAL	L_USB_CheckIn6
;USB_Driver.c,117 :: 		case 'i':  // Set Normal display mode
L_USB_CheckIn15:
;USB_Driver.c,118 :: 		Normal();
BL	_Normal+0
;USB_Driver.c,119 :: 		break;
IT	AL
BAL	L_USB_CheckIn6
;USB_Driver.c,120 :: 		case 'j':  // Does not work
L_USB_CheckIn16:
;USB_Driver.c,121 :: 		BlinkSlow();
BL	_BlinkSlow+0
;USB_Driver.c,122 :: 		break;
IT	AL
BAL	L_USB_CheckIn6
;USB_Driver.c,123 :: 		case 'k':  // Does not work
L_USB_CheckIn17:
;USB_Driver.c,124 :: 		BlinkFast();
BL	_BlinkFast+0
;USB_Driver.c,125 :: 		break;
IT	AL
BAL	L_USB_CheckIn6
;USB_Driver.c,126 :: 		case 'l':
L_USB_CheckIn18:
;USB_Driver.c,127 :: 		BlinkOff();
BL	_BlinkOff+0
;USB_Driver.c,128 :: 		break;
IT	AL
BAL	L_USB_CheckIn6
;USB_Driver.c,129 :: 		case 'm':  // Turn all segments of the display on for test
L_USB_CheckIn19:
;USB_Driver.c,130 :: 		DispTest(0x01);
MOVS	R0, #1
BL	_DispTest+0
;USB_Driver.c,131 :: 		break;
IT	AL
BAL	L_USB_CheckIn6
;USB_Driver.c,132 :: 		case 'n':  // End test
L_USB_CheckIn20:
;USB_Driver.c,133 :: 		DispTest(0x00);
MOVS	R0, #0
BL	_DispTest+0
;USB_Driver.c,134 :: 		break;
IT	AL
BAL	L_USB_CheckIn6
;USB_Driver.c,135 :: 		case 'o':
L_USB_CheckIn21:
;USB_Driver.c,137 :: 		break;
IT	AL
BAL	L_USB_CheckIn6
;USB_Driver.c,138 :: 		case 'p':
L_USB_CheckIn22:
;USB_Driver.c,140 :: 		break;
IT	AL
BAL	L_USB_CheckIn6
;USB_Driver.c,141 :: 		case 'q':
L_USB_CheckIn23:
;USB_Driver.c,143 :: 		break;
IT	AL
BAL	L_USB_CheckIn6
;USB_Driver.c,144 :: 		case 'r':
L_USB_CheckIn24:
;USB_Driver.c,146 :: 		break;
IT	AL
BAL	L_USB_CheckIn6
;USB_Driver.c,147 :: 		case 's':
L_USB_CheckIn25:
;USB_Driver.c,149 :: 		break;
IT	AL
BAL	L_USB_CheckIn6
;USB_Driver.c,150 :: 		case 't':  // Blink enable (should be 1 second on/off)
L_USB_CheckIn26:
;USB_Driver.c,151 :: 		Test(0x03);
MOVS	R0, #3
BL	_Test+0
;USB_Driver.c,152 :: 		break;
IT	AL
BAL	L_USB_CheckIn6
;USB_Driver.c,153 :: 		case 'u':  // Bit D2 does nothing
L_USB_CheckIn27:
;USB_Driver.c,154 :: 		Test(0x07);
MOVS	R0, #7
BL	_Test+0
;USB_Driver.c,155 :: 		break;
IT	AL
BAL	L_USB_CheckIn6
;USB_Driver.c,156 :: 		case 'v':  // Bit D4 does nothing
L_USB_CheckIn28:
;USB_Driver.c,157 :: 		Test(0x09);
MOVS	R0, #9
BL	_Test+0
;USB_Driver.c,158 :: 		break;
IT	AL
BAL	L_USB_CheckIn6
;USB_Driver.c,159 :: 		case 'w':  // Increment through all possible codes of the Configuration register
L_USB_CheckIn29:
;USB_Driver.c,160 :: 		Increment();
BL	_Increment+0
;USB_Driver.c,161 :: 		break;
IT	AL
BAL	L_USB_CheckIn6
;USB_Driver.c,162 :: 		case 'x':  // Force normal mode
L_USB_CheckIn30:
;USB_Driver.c,163 :: 		Test(0x01);
MOVS	R0, #1
BL	_Test+0
;USB_Driver.c,164 :: 		break;
IT	AL
BAL	L_USB_CheckIn6
;USB_Driver.c,165 :: 		case 'y':
L_USB_CheckIn31:
;USB_Driver.c,167 :: 		break;
IT	AL
BAL	L_USB_CheckIn6
;USB_Driver.c,168 :: 		case 'z':  // Force a system reset
L_USB_CheckIn32:
;USB_Driver.c,169 :: 		SystemReset();
BL	_SystemReset+0
;USB_Driver.c,170 :: 		break;
IT	AL
BAL	L_USB_CheckIn6
;USB_Driver.c,174 :: 		default:  // Catch all other unimplemented commands
L_USB_CheckIn33:
;USB_Driver.c,175 :: 		BufNum = GetBuffer();  // Get a free buffer
BL	_GetBuffer+0
; BufNum start address is: 12 (R3)
MOV	R3, R0
;USB_Driver.c,176 :: 		(void)sprintf(BufNum,"Unknown command: %c\r\n",readbuff[0]);
MOVW	R1, #lo_addr(_readbuff+0)
MOVT	R1, #hi_addr(_readbuff+0)
LDRB	R2, [R1, #0]
MOVW	R1, #lo_addr(?lstr_3_USB_Driver+0)
MOVT	R1, #hi_addr(?lstr_3_USB_Driver+0)
STR	R3, [SP, #4]
PUSH	(R2)
PUSH	(R1)
PUSH	(R0)
BL	_sprintf+0
ADD	SP, SP, #12
LDR	R3, [SP, #4]
;USB_Driver.c,177 :: 		USB_PutQueue(BufNum);
MOV	R0, R3
; BufNum end address is: 12 (R3)
BL	_USB_PutQueue+0
;USB_Driver.c,178 :: 		break;
IT	AL
BAL	L_USB_CheckIn6
;USB_Driver.c,179 :: 		}
L_USB_CheckIn5:
MOVW	R0, #lo_addr(_readbuff+0)
MOVT	R0, #hi_addr(_readbuff+0)
LDRB	R0, [R0, #0]
CMP	R0, #97
IT	EQ
BEQ	L_USB_CheckIn7
MOVW	R0, #lo_addr(_readbuff+0)
MOVT	R0, #hi_addr(_readbuff+0)
LDRB	R0, [R0, #0]
CMP	R0, #98
IT	EQ
BEQ	L_USB_CheckIn8
MOVW	R0, #lo_addr(_readbuff+0)
MOVT	R0, #hi_addr(_readbuff+0)
LDRB	R0, [R0, #0]
CMP	R0, #99
IT	EQ
BEQ	L_USB_CheckIn9
MOVW	R0, #lo_addr(_readbuff+0)
MOVT	R0, #hi_addr(_readbuff+0)
LDRB	R0, [R0, #0]
CMP	R0, #100
IT	EQ
BEQ	L_USB_CheckIn10
MOVW	R0, #lo_addr(_readbuff+0)
MOVT	R0, #hi_addr(_readbuff+0)
LDRB	R0, [R0, #0]
CMP	R0, #101
IT	EQ
BEQ	L_USB_CheckIn11
MOVW	R0, #lo_addr(_readbuff+0)
MOVT	R0, #hi_addr(_readbuff+0)
LDRB	R0, [R0, #0]
CMP	R0, #102
IT	EQ
BEQ	L_USB_CheckIn12
MOVW	R0, #lo_addr(_readbuff+0)
MOVT	R0, #hi_addr(_readbuff+0)
LDRB	R0, [R0, #0]
CMP	R0, #103
IT	EQ
BEQ	L_USB_CheckIn13
MOVW	R0, #lo_addr(_readbuff+0)
MOVT	R0, #hi_addr(_readbuff+0)
LDRB	R0, [R0, #0]
CMP	R0, #104
IT	EQ
BEQ	L_USB_CheckIn14
MOVW	R0, #lo_addr(_readbuff+0)
MOVT	R0, #hi_addr(_readbuff+0)
LDRB	R0, [R0, #0]
CMP	R0, #105
IT	EQ
BEQ	L_USB_CheckIn15
MOVW	R0, #lo_addr(_readbuff+0)
MOVT	R0, #hi_addr(_readbuff+0)
LDRB	R0, [R0, #0]
CMP	R0, #106
IT	EQ
BEQ	L_USB_CheckIn16
MOVW	R0, #lo_addr(_readbuff+0)
MOVT	R0, #hi_addr(_readbuff+0)
LDRB	R0, [R0, #0]
CMP	R0, #107
IT	EQ
BEQ	L_USB_CheckIn17
MOVW	R0, #lo_addr(_readbuff+0)
MOVT	R0, #hi_addr(_readbuff+0)
LDRB	R0, [R0, #0]
CMP	R0, #108
IT	EQ
BEQ	L_USB_CheckIn18
MOVW	R0, #lo_addr(_readbuff+0)
MOVT	R0, #hi_addr(_readbuff+0)
LDRB	R0, [R0, #0]
CMP	R0, #109
IT	EQ
BEQ	L_USB_CheckIn19
MOVW	R0, #lo_addr(_readbuff+0)
MOVT	R0, #hi_addr(_readbuff+0)
LDRB	R0, [R0, #0]
CMP	R0, #110
IT	EQ
BEQ	L_USB_CheckIn20
MOVW	R0, #lo_addr(_readbuff+0)
MOVT	R0, #hi_addr(_readbuff+0)
LDRB	R0, [R0, #0]
CMP	R0, #111
IT	EQ
BEQ	L_USB_CheckIn21
MOVW	R0, #lo_addr(_readbuff+0)
MOVT	R0, #hi_addr(_readbuff+0)
LDRB	R0, [R0, #0]
CMP	R0, #112
IT	EQ
BEQ	L_USB_CheckIn22
MOVW	R0, #lo_addr(_readbuff+0)
MOVT	R0, #hi_addr(_readbuff+0)
LDRB	R0, [R0, #0]
CMP	R0, #113
IT	EQ
BEQ	L_USB_CheckIn23
MOVW	R0, #lo_addr(_readbuff+0)
MOVT	R0, #hi_addr(_readbuff+0)
LDRB	R0, [R0, #0]
CMP	R0, #114
IT	EQ
BEQ	L_USB_CheckIn24
MOVW	R0, #lo_addr(_readbuff+0)
MOVT	R0, #hi_addr(_readbuff+0)
LDRB	R0, [R0, #0]
CMP	R0, #115
IT	EQ
BEQ	L_USB_CheckIn25
MOVW	R0, #lo_addr(_readbuff+0)
MOVT	R0, #hi_addr(_readbuff+0)
LDRB	R0, [R0, #0]
CMP	R0, #116
IT	EQ
BEQ	L_USB_CheckIn26
MOVW	R0, #lo_addr(_readbuff+0)
MOVT	R0, #hi_addr(_readbuff+0)
LDRB	R0, [R0, #0]
CMP	R0, #117
IT	EQ
BEQ	L_USB_CheckIn27
MOVW	R0, #lo_addr(_readbuff+0)
MOVT	R0, #hi_addr(_readbuff+0)
LDRB	R0, [R0, #0]
CMP	R0, #118
IT	EQ
BEQ	L_USB_CheckIn28
MOVW	R0, #lo_addr(_readbuff+0)
MOVT	R0, #hi_addr(_readbuff+0)
LDRB	R0, [R0, #0]
CMP	R0, #119
IT	EQ
BEQ	L_USB_CheckIn29
MOVW	R0, #lo_addr(_readbuff+0)
MOVT	R0, #hi_addr(_readbuff+0)
LDRB	R0, [R0, #0]
CMP	R0, #120
IT	EQ
BEQ	L_USB_CheckIn30
MOVW	R0, #lo_addr(_readbuff+0)
MOVT	R0, #hi_addr(_readbuff+0)
LDRB	R0, [R0, #0]
CMP	R0, #121
IT	EQ
BEQ	L_USB_CheckIn31
MOVW	R0, #lo_addr(_readbuff+0)
MOVT	R0, #hi_addr(_readbuff+0)
LDRB	R0, [R0, #0]
CMP	R0, #122
IT	EQ
BEQ	L_USB_CheckIn32
IT	AL
BAL	L_USB_CheckIn33
L_USB_CheckIn6:
;USB_Driver.c,180 :: 		}
L_USB_CheckIn4:
;USB_Driver.c,181 :: 		}
L_end_USB_CheckIn:
LDR	LR, [SP, #0]
ADD	SP, SP, #8
BX	LR
; end of _USB_CheckIn
