#line 1 "C:/ARM Projects/Mikromedia for STM32 M4/LED Display Driver/Code/USB_Driver.c"
#line 1 "c:/arm projects/mikromedia for stm32 m4/led display driver/code/usb_driver.h"
#line 11 "c:/arm projects/mikromedia for stm32 m4/led display driver/code/usb_driver.h"
typedef char *pnt;


typedef struct USB_TxStruct {
 unsigned int in;
 unsigned int out;
 pnt q[ 32 ];
}USB_TxStruct;



void USB_Init(void);
void USB_TxQueueInit(void);
void USB_PutQueue(char *msg);
void USB_CheckOut(void);
void USB_CheckIn(void);
#line 1 "c:/arm projects/mikromedia for stm32 m4/led display driver/code/buffers.h"
#line 15 "c:/arm projects/mikromedia for stm32 m4/led display driver/code/buffers.h"
char* GetBuffer(void);
#line 1 "c:/arm projects/mikromedia for stm32 m4/led display driver/code/led_driver.h"
#line 25 "c:/arm projects/mikromedia for stm32 m4/led display driver/code/led_driver.h"
void Display_Init(void);
void Display_Write(unsigned _data);
void Display_Setup(void);
char DisplayAll(char *Msg);
void SetDigit(char Digit, char _data, char DecPt);
void SetDecodeReg(char Mask);
void LowerIntensity(void);
void RaiseIntensity(void);

void Shutdown(void);
void Normal(void);
void BlinkSlow(void);
void BlinkFast(void);
void BlinkOff(void);

void Test(char Mask);
void Increment(void);
void DispTest(char OnOff);
#line 1 "c:/users/public/documents/mikroelektronika/mikroc pro for arm/include/built_in.h"
#line 12 "C:/ARM Projects/Mikromedia for STM32 M4/LED Display Driver/Code/USB_Driver.c"
char readbuff[64];
char writebuff[64];

USB_TxStruct USB_Queue;

char TempBuf[] = "01234567";
#line 23 "C:/ARM Projects/Mikromedia for STM32 M4/LED Display Driver/Code/USB_Driver.c"
void USBInterrupt() iv IVT_INT_OTG_FS ics ICS_AUTO {
 USB_Interrupt_Proc();
}
#line 30 "C:/ARM Projects/Mikromedia for STM32 M4/LED Display Driver/Code/USB_Driver.c"
void USB_Init(void) {



 HID_Enable(&readbuff,&writebuff);
 USB_TxQueueInit();

}
#line 42 "C:/ARM Projects/Mikromedia for STM32 M4/LED Display Driver/Code/USB_Driver.c"
void USB_TxQueueInit(void) {

 USB_Queue.in = 0;
 USB_Queue.out = 0;
}
#line 52 "C:/ARM Projects/Mikromedia for STM32 M4/LED Display Driver/Code/USB_Driver.c"
void USB_PutQueue(char *msg) {

 USB_Queue.q[USB_Queue.in++] = msg;
 if (USB_Queue.in > ( 32 -1))
 USB_Queue.in = 0;
}
#line 65 "C:/ARM Projects/Mikromedia for STM32 M4/LED Display Driver/Code/USB_Driver.c"
void USB_CheckOut(void) {

 if (USB_Queue.in != USB_Queue.out) {


 if (HID_Write(USB_Queue.q[USB_Queue.out],64) != 0) {
 USB_Queue.out++;
 if (USB_Queue.out > ( 32 -1))
 USB_Queue.out = 0;
 }
 }
}
#line 83 "C:/ARM Projects/Mikromedia for STM32 M4/LED Display Driver/Code/USB_Driver.c"
void USB_CheckIn(void) {
 char *BufNum;
 unsigned CmdDat;

 if (HID_Read() != 0) {
 switch (readbuff[0]) {

 case 'a':
 BufNum = GetBuffer();
 sprintf(BufNum,"Command 'a' received");
 USB_PutQueue(BufNum);
 break;
 case 'b':
 USB_PutQueue("Command 'b' received");
 break;
 case 'c':
 DisplayAll(&TempBuf);
 break;
 case 'd':
 SetDigit(0,0x0A,0);
 break;
 case 'e':
 SetDigit(0,0x00,0);
 SetDecodeReg(0xFE);
 break;
 case 'f':
 LowerIntensity();
 break;
 case 'g':
 RaiseIntensity();
 break;
 case 'h':
 Shutdown();
 break;
 case 'i':
 Normal();
 break;
 case 'j':
 BlinkSlow();
 break;
 case 'k':
 BlinkFast();
 break;
 case 'l':
 BlinkOff();
 break;
 case 'm':
 DispTest(0x01);
 break;
 case 'n':
 DispTest(0x00);
 break;
 case 'o':

 break;
 case 'p':

 break;
 case 'q':

 break;
 case 'r':

 break;
 case 's':

 break;
 case 't':
 Test(0x03);
 break;
 case 'u':
 Test(0x07);
 break;
 case 'v':
 Test(0x09);
 break;
 case 'w':
 Increment();
 break;
 case 'x':
 Test(0x01);
 break;
 case 'y':

 break;
 case 'z':
 SystemReset();
 break;



 default:
 BufNum = GetBuffer();
 (void)sprintf(BufNum,"Unknown command: %c\r\n",readbuff[0]);
 USB_PutQueue(BufNum);
 break;
 }
 }
}
